#####################################################
## select candidate regions by smoothing
#####################################################
select.candidate <- function(data, cfg) {
  signal=data$signal
  vars=data$vars
  allchr=data$allchr
  allpos=data$allpos
  nreps=data$nreps
  ncond=dim(signal)[2]
  nobs=dim(signal)[1]

  ## prefilter regions to get candidate regions
  ## and run EM to get emission probabilities
  tmp <- prefilter(signal, vars, allchr, allpos, sep=cfg$peak$maxGap,
                   min(cfg$peak$bumpLength), candidateLength=cfg$peak$candidateLength,nreps)
  idx.sig <- tmp$idx
  distn <- tmp$distn
  ## compute prior for candidates - how to do this??
  pi <- length(idx.sig) / nobs
#  regions <- findRegion(allchr[idx.sig], allpos[idx.sig], cfg$peak$maxGap)
#  pi <- ncol(regions) / nobs #-length(idx.sig))
  if(is.matrix(vars)) {
    candidates <- list(signal=signal[idx.sig,], vars=vars[idx.sig,],
                 allchr=allchr[idx.sig], allpos=allpos[idx.sig],
                 nreps=nreps, distn=distn, pi=pi)
  }   else {
    candidates <- list(signal=signal[idx.sig,], vars=0,
                 allchr=allchr[idx.sig], allpos=allpos[idx.sig],
                 nreps=nreps, distn=distn, pi=pi)
  }
  
  ## return
  invisible(candidates)
}
